%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Programming Assignment 6
%
%  Single Shooting Method
%
%  The following files will be generated as the result of this script
%   prob1_tol2.ps; prob1_tol4.ps; prob1_tol6.ps; 
%   prob2_tol2.ps; prob2_tol4.ps; prob2_tol6.ps;
%   src.txt; src_4p.ps; res.txt; res_4p.ps; 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
!rm src.txt
!rm res.txt
!rm *.ps

diary res.txt

prognr='06';
verf(1,:)='expEul'; color(1,:)=' -b';
verf(2,:)='modEul'; color(2,:)=' :m';
verf(3,:)='Heun  '; color(3,:)='-.g';
verf(4,:)='clRK  '; color(4,:)='--k';

choice=1;choicemax=3;
while(choice<choicemax+1)
choice=menu(['Programming assignment PA ',prognr],...
            'for Problem 1',...
            'for Problem 2',...
            'for all problems',...
            'End');

if(choice<choicemax+1)
tol=menu('Tolerance',...
            '10^-1',...
            '10^-2',...
            '10^-3',...
            '10^-4',...
            '10^-5',...
            '10^-6',...
            'for all');
if tol==7, tol=1:6; end;

close all

%Problem 1
if(choice==1|choice==choicemax)
testnr=1;
disp(['Programming assignment',num2str(prognr),' - Problem ',num2str(testnr)])
a=0;n=2;y0i=[1];y0=[0];s0i=[2];s0=[1];y1i=[1];y1=[1];N=100;l=pi/4;
[y]=exsol6(a:l/N:a+l);
for i=tol
figure;
for j=2:2:6  %ds=10^-1 : 10^-6
[h,t,u1,s1,z1]=shooting('funct6',but(1),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e1=abs(u1(1,:)-y);ne1(i,j)=norm(e1,2)*h;
[h,t,u2,s2,z2]=shooting('funct6',but(2),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e2=abs(u2(1,:)-y);ne2(i,j)=norm(e2,2)*h;
[h,t,u3,s3,z3]=shooting('funct6',but(3),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e3=abs(u3(1,:)-y);ne3(i,j)=norm(e3,2)*h;
[h,t,u4,s4,z4]=shooting('funct6',but(4),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e4=abs(u4(1,:)-y);ne4(i,j)=norm(e4,2)*h;
if(((i==2|i==4|i==6)&(j==2|j==4|j==6))|(length(tol)==1))
disp(['Tol=',num2str(10^(-i)),' ds=',num2str(10^(-j))]);
disp(['    MESH t with STEP SIZE']);
disp(['   ',num2str(t(1:N/5:N+1),'  %11.3e')]);
disp(['    EXACT SOL.  APPROX. SOL.   ',verf(1,:),'        ',verf(2,:),'        ',verf(3,:),'    ',verf(4,:)]);
disp(['    ',num2str(y (1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u1(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u2(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u3(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u4(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ERROR e     APPROX. SOL.  ',                verf(1,:),'        ',verf(2,:),'        ',verf(3,:),'     ',verf(4,:)]);
disp(['    ',num2str(e1(1:N(1)/5:N(1)+1),'  %11.3e')]);
disp(['    ',num2str(e2(1:N(1)/5:N(1)+1),'  %11.3e')]);
disp(['    ',num2str(e3(1:N(1)/5:N(1)+1),'  %11.3e')]);
disp(['    NUMBER OF ITER. AND STARTING VALUES s FOR  ']);
disp(['  ' verf(1,:),'       ',verf(2,:), '        ',verf(3,:),'      ',verf(4,:)]);
disp(['    ',num2str([z1,z2,z3,z4],'  %11i')]);
disp(['    ',num2str([s1(z1),s2(z2),s3(z3),s4(z4)],'  %11.3e')]);
%disp(['    FLOPS FOR ',verf(1,:),', ',verf(2,:),', ',verf(3,:),', ',verf(4,:)]);
%disp(['    ',num2str([fl1(i,j),fl2(i,j),fl3(i,j),fl4(i,j)],'  %11i')]);
subplot(4,3,(j/2-1)+1);
  plot(t,y,'r');hold on;
  plot(t,u1(1,:),color(1,:));plot(t,u2(1,:),color(2,:));plot(t,u3(1,:),color(3,:));plot(t,u4(1,:),color(4,:));
  axis tight; box on; grid;
  title(['P',num2str(prognr),' - TEST PROBLEM ',num2str(testnr),'  [','Tol=',num2str(10^(-i)),' ds=',num2str(10^(-j)),']']);
subplot(4,3,(j/2-1)+4);
  plot(t,e1,color(1,:));hold on; plot(t,e2,color(2,:)); plot(t,e3,color(3,:)); plot(t,e4,color(4,:));
  axis tight; box on; grid;
  title('ERROR');
subplot(4,3,(j/2-1)+7);
  semilogy(t,e1,color(1,:));hold on; semilogy(t,e2,color(2,:)); semilogy(t,e3,color(3,:)); semilogy(t,e4,color(4,:));
  axis tight; box on; grid;
  title('ERROR LOG');
subplot(4,3,(j/2-1)+10);
  plot(s1,[color(1,3),'*']);hold on; plot(s2,[color(2,3),'+']); plot(s3,[color(3,3),'s']); plot(s4,[color(4,3),'o']);
  axis tight; box on; grid;
  title('SEUENCE OF STARTING VALUES');
  if j==2, xlabel(['[(-r) exakt] [(',color(1,:),') ',verf(1,:),']']);end;
  if j==4, xlabel(['[(',color(2,:),') ',verf(2,:),'] [(',color(3,:),') ',verf(3,:),']']);end;
  if j==6, xlabel(['[(',color(4,:),') ',verf(4,:),']']);end;
orient landscape; 
if i== 2, print -dps prob1_tol2.ps; end;
if i== 4, print -dps prob1_tol4.ps; end;
if i== 6, print -dps prob1_tol6.ps; end;
end; % if i,j grade
end; % for j=ds
end; % for i=tol
figure;
for j=2:2:6  %ds=10^-1 : 10^-6
subplot(3,3,1+(j/2-1));
%  loglog(10.^(-tol),fl1(:,j),[color(1,:),'s']);hold on;loglog(10.^(-tol),fl2(:,j),[color(2,:),'s']);loglog(10.^(-tol),fl3(:,j),[color(3,:),'s']);loglog(10.^(-tol),fl4(:,j),[color(4,:),'s']);
%  title(['\bf Computational cost P',prognr,' - TEST PROBLEM ',testnr,'  [ds=',num2str(10^(-j)),']']);xlabel('10.^(-tol)erance 10.^(-tol)');ylabel('Flops');
%subplot(3,3,4+(j/2-1));
  loglog(10.^(-tol),ne1(:,j),[color(1,:),'s']);hold on;loglog(10.^(-tol),ne2(:,j),[color(2,:),'s']);loglog(10.^(-tol),ne3(:,j),[color(3,:),'s']);loglog(10.^(-tol),ne4(:,j),[color(4,:),'s']);
  title('\bf Accuracy');xlabel('10.^(-tol)erance 10.^(-tol)');ylabel('absolute Error');
%subplot(3,3,7+(j/2-1));
 % loglog(fl1(:,j),ne1(:,j),[color(1,:),'s']);hold on;loglog(fl2(:,j),ne2(:,j),[color(2,:),'s']);loglog(fl3(:,j),ne3(:,j),[color(3,:),'s']);loglog(fl4(:,j),ne4(:,j),[color(4,:),'s']);
 % title('\bf Efficiency');ylabel('absolute Error');
 % if j==2, xlabel(['Computational cost in flops      ';'[(-r) exakt] [(',color(1,:),'s) ',verf(1,:),']']); end;
 % if j==4, xlabel(['Computational cost in flops         ';'[(',color(2,:),'s) ',verf(2,:),'] [(',color(3,:),'s) ',verf(3,:),']']); end;
 % if j==6, xlabel(['Computational cost in flops';'[(',color(4,:),'s) ',verf(4,:),']       ']); end;
end;
%legend1 = legend('a','b','c')
%set(legend1, 'Position', [30 30 120 35]);
%orient landscape;print -dps prob1_flerr.ps;
disp(' ');
end; % if choice==1

%Problem 2
if(choice==2|choice==choicemax)
testnr=2;
disp(['Programming assignment PA ',num2str(prognr),' - Problem ',num2str(testnr)])
l=.1;a=.88;
n=1;y0i=[];y0=[];s0i=[1];s0=[-1];y1i=[1];y1=[cos(1/(1.05-(a+l)))];N=1000;
[y]=exsol9(a:l/N:a+l);
for i=tol
figure;
for j=2:2:6  %ds=10^-1 : 10^-6
[h,t,u1,s1,z1]=shooting('funct9',but(1),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e1=abs(u1(1,:)-y);ne1(i,j)=norm(e1,2)*h;
[h,t,u2,s2,z2]=shooting('funct9',but(2),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e2=abs(u2(1,:)-y);ne2(i,j)=norm(e2,2)*h;
[h,t,u3,s3,z3]=shooting('funct9',but(3),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e3=abs(u3(1,:)-y);ne3(i,j)=norm(e3,2)*h;
[h,t,u4,s4,z4]=shooting('funct9',but(4),a,n,y0i,y0,s0i,s0,y1i,y1,N,l,10^(-j),10^(-i)); e4=abs(u4(1,:)-y);ne4(i,j)=norm(e4,2)*h;
if(((i==2|i==4|i==6)&(j==2|j==4|j==6))|(length(tol)==1))
disp(['Tol=',num2str(10^(-i)),' ds=',num2str(10^(-j))]);
disp(['    MESH t with STEP SIZE']);
disp(['   ',num2str(t(1:N/5:N+1),'  %11.3e')]);
disp(['    EXACT SOL.  APPROX. SOL.   ',verf(1,:),'        ',verf(2,:),'        ',verf(3,:),'    ',verf(4,:)]);
disp(['    ',num2str(y (1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u1(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u2(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u3(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ',num2str(u4(1,1:N/5:N+1),'  %11.3e')]);
disp(['    ERROR e     APPROX. SOL.  ',                verf(1,:),'        ',verf(2,:),'        ',verf(3,:),'     ',verf(4,:)]);
disp(['    ',num2str(e1(1:N(1)/5:N(1)+1),'  %11.3e')]);
disp(['    ',num2str(e2(1:N(1)/5:N(1)+1),'  %11.3e')]);
disp(['    ',num2str(e3(1:N(1)/5:N(1)+1),'  %11.3e')]);
disp(['    NUMBER OF ITER. AND STARTING VALUES s FOR  ']);
disp(['  ' verf(1,:),'       ',verf(2,:), '        ',verf(3,:),'      ',verf(4,:)]);
disp(['    ',num2str([z1,z2,z3,z4],'  %11i')]);
disp(['    ',num2str([s1(z1),s2(z2),s3(z3),s4(z4)],'  %11.3e')]);
%disp(['    FLOPS FOR ',verf(1,:),', ',verf(2,:),', ',verf(3,:),', ',verf(4,:)]);
%disp(['    ',num2str([fl1(i,j),fl2(i,j),fl3(i,j),fl4(i,j)],'  %11i')]);
subplot(4,3,(j/2-1)+1);
  plot(t,y,'r');hold on;
  plot(t,u1(1,:),color(1,:));plot(t,u2(1,:),color(2,:));plot(t,u3(1,:),color(3,:));plot(t,u4(1,:),color(4,:));
  axis tight; box on; grid;
  title(['P',num2str(prognr),' - TEST PROBLEM ',num2str(testnr),'  [','Tol=',num2str(10^(-i)),' ds=',num2str(10^(-j)),']']);
subplot(4,3,(j/2-1)+4);
  plot(t,e1,color(1,:));hold on; plot(t,e2,color(2,:)); plot(t,e3,color(3,:)); plot(t,e4,color(4,:));
  axis tight; box on; grid;
  title('ERROR');
subplot(4,3,(j/2-1)+7);
  semilogy(t,e1,color(1,:));hold on; semilogy(t,e2,color(2,:)); semilogy(t,e3,color(3,:)); semilogy(t,e4,color(4,:));
  axis tight; box on; grid;
  title('ERROR LOG');
subplot(4,3,(j/2-1)+10);
  plot(s1,[color(1,3),'*']);hold on; plot(s2,[color(2,3),'+']); plot(s3,[color(3,3),'s']); plot(s4,[color(4,3),'o']);
  axis tight; box on; grid;
  title('SEQUENCE OF STARTING VALUES');
  if j==2, xlabel(['[(-r) exakt] [(',color(1,:),') ',verf(1,:),']']);end;
  if j==4, xlabel(['[(',color(2,:),') ',verf(2,:),'] [(',color(3,:),') ',verf(3,:),']']);end;
  if j==6, xlabel(['[(',color(4,:),') ',verf(4,:),']']);end;
orient landscape; 
if i== 2, print -dps prob2_tol2.ps; end;
if i== 4, print -dps prob2_tol4.ps; end;
if i== 6, print -dps prob2_tol6.ps; end;
end; % if i,j grade
end; % for j=ds
end; % for i=tol
figure;
for j=2:2:6  %ds=10^-1 : 10^-6
subplot(3,3,1+(j/2-1));
  %loglog(10.^(-tol),fl1(:,j),[color(1,:),'s']);hold on;loglog(10.^(-tol),fl2(:,j),[color(2,:),'s']);loglog(10.^(-tol),fl3(:,j),[color(3,:),'s']);loglog(10.^(-tol),fl4(:,j),[color(4,:),'s']);
  %title(['\bf Computational cost P',prognr,' - TEST PROBLEM ',testnr,'  [ds=',num2str(10^(-j)),']']);xlabel('10.^(-tol)erance 10.^(-tol)');ylabel('Flops');
%subplot(3,3,4+(j/2-1));
  loglog(10.^(-tol),ne1(:,j),[color(1,:),'s']);hold on;loglog(10.^(-tol),ne2(:,j),[color(2,:),'s']);loglog(10.^(-tol),ne3(:,j),[color(3,:),'s']);loglog(10.^(-tol),ne4(:,j),[color(4,:),'s']);
  title('\bf Accuracy');xlabel('10.^(-tol)erance 10.^(-tol)');ylabel('absolute Error');
%subplot(3,3,7+(j/2-1));
 % loglog(fl1(:,j),ne1(:,j),[color(1,:),'s']);hold on;loglog(fl2(:,j),ne2(:,j),[color(2,:),'s']);loglog(fl3(:,j),ne3(:,j),[color(3,:),'s']);loglog(fl4(:,j),ne4(:,j),[color(4,:),'s']);
 % title('\bf Efficiency');ylabel('absolute Error');
 % if j==2, xlabel(['Computational cost in flops      ';'[(-r) exakt] [(',color(1,:),'s) ',verf(1,:),']']); end;
 % if j==4, xlabel(['Computational cost in flops         ';'[(',color(2,:),'s) ',verf(2,:),'] [(',color(3,:),'s) ',verf(3,:),']']); end;
 % if j==6, xlabel(['computational cost in flops';'[(',color(4,:),'s) ',verf(4,:),']       ']); end;
end;
%orient landscape;print -dps prob2_flerr.ps;
disp(' ');
end; % if choice==2

diary off



end; % if choice<choicemax+1
end; % while choice

if(1==menu('Figures','Close figures ','Keep figures')), close all; end;

! more shooting.m >src.txt
! mpage -4A src.txt > src_4p.ps
! mpage -4A res.txt > res_4p.ps
disp(' ');
disp('src_4p.ps      - Code for shooting.m');
disp('res_4p.ps      - Numerical approximations in mesh points');
disp('prob?_tol*.ps  - Plots for Problem ? with tolerance 10^{-*}');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
